import java.io.File;
import java.io.IOException;
import java.nio.file.FileSystems;
import java.nio.file.FileVisitResult;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.PathMatcher;
import java.nio.file.SimpleFileVisitor;
import java.nio.file.attribute.BasicFileAttributes;
import java.util.List;
import static java.nio.file.FileVisitResult.*;
import java.util.*;
import javafx.scene.control.Label;
import javafx.scene.canvas.Canvas;
import javafx.scene.paint.*;
import javafx.scene.canvas.*;
import javafx.scene.media.MediaView;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.AudioSpectrumListener;

@SuppressWarnings("unused")
public class findFiles {

    public List<String> filesFound = new ArrayList<String>();
	Label label = null;
	GraphicsContext gc = null;
	private double[] xp = new double[128];
	private double[] yp = new double[128];
	private double step = 1;
	private double canvasWidth = 0;
	private double canvasHeight = 0;
	private int bars = 0;
	private boolean atEndOfMedia = false;
	
        public class Finder
                extends SimpleFileVisitor<Path> {

            private final PathMatcher matcher;
            private int numMatches = 0;

            Finder(String pattern) {
                matcher = FileSystems.getDefault()
                        .getPathMatcher("glob:" + pattern);
            }

            // Compares the glob pattern against
            // the file or directory name.
            void find(Path file) {
                Path name = file.getFileName();
                if (name != null && matcher.matches(name)) {
                    numMatches++;
                    label.setText("Found : " + numMatches);
					Thread.yield();
					filesFound.add(file.toAbsolutePath().toString().replace("\\","/"));
                }
            }

            // Invoke the pattern matching
            // method on each file.
            @Override
            public FileVisitResult visitFile(Path file,
                    BasicFileAttributes attrs) {
                find(file);
                return CONTINUE;
            }

            // Invoke the pattern matching
            // method on each directory.
            @Override
            public FileVisitResult preVisitDirectory(Path dir,
                    BasicFileAttributes attrs) {
                find(dir);
                return CONTINUE;
            }

            @Override
            public FileVisitResult visitFileFailed(Path file,
                    IOException exc) {
                System.err.println(exc);
                return CONTINUE;
            }

    }
	@SuppressWarnings("all")
	public Object findFiles(String dir, String pattern,Label l)
                throws IOException {
            label = l;
			File f = new File(dir);
            Path startingDir = f.toPath();
            Finder finder = new Finder(pattern);
            Files.walkFileTree(startingDir, finder);

			return filesFound;
    } 

	public Object getProgress(MediaPlayer mp){
			return mp.getBufferProgressTime();
	}
	public int getDurationInSeconds(MediaPlayer mp){
			return  (int) mp.getTotalDuration().toSeconds();
	}
	public String getDurationFormatted(MediaPlayer mp){
			String result = "";
			//result = ((int) mp.getTotalDuration().toSeconds() / 60) + ":" + ((int) mp.getTotalDuration().toSeconds() % 60);
			result = String.format("%02d:%02d",((int) mp.getTotalDuration().toSeconds() / 60),((int) mp.getTotalDuration().toSeconds() % 60));
			return result;
	}
	public String getMediaPlayerStatus(MediaPlayer mp){
		return mp.getStatus().toString();
	}
	public void setEndOfMedia(final MediaPlayer mp){
		mp.setOnEndOfMedia(new Runnable() {
			@Override
			public void run()
			{
			atEndOfMedia = true;
			mp.stop();
			}
		});
	}
	public boolean mediaFinished(){
		return atEndOfMedia;
	}
	public void spectrumBars(MediaPlayer mp, Canvas c, Label barLabel, Integer b){
		bars = b;
		barLabel.setText("Monitoring " + bars + " frequencies.");
		canvasWidth = c.getWidth();
		canvasHeight = c.getHeight();
		mp.setAudioSpectrumNumBands(bars);
		step = canvasWidth / bars;
		for (int xx = 0;xx<128;xx++){
				xp[xx] = (xx * step);
            }
		xp[0] = 0;
		mp.setAudioSpectrumInterval(0.1);
		mp.setAudioSpectrumThreshold(-100);
		gc = c.getGraphicsContext2D();
		gc.setFill(Color.SILVER);
		gc.setStroke(Color.DARKRED);
		gc.setLineWidth(1);
		mp.setAudioSpectrumListener(new AudioSpectrumListener() {
			@Override
			public void spectrumDataUpdate(double timestamp, double duration,float[] magnitudes, float[] phases) {
				gc.fillRect(0,0,canvasWidth,canvasHeight);
				int l = magnitudes.length;
				for (int xx = 0;xx<l;xx++){
					//yp[xx] = 75 +  (phases[xx] *  ((100 - (magnitudes[xx]) * -0.75)));
					yp[xx] = canvasHeight -  ((100 + magnitudes[xx])*(canvasHeight / 100));
					}
				gc.strokePolyline(xp,yp,l);
			}
		});
	}
}
